<?php

define('IN_FS', true);

require_once(dirname(__FILE__).'/header.php');
//require_once(dirname(__FILE__).'/includes/class.tpl.php');
require_once(dirname(__FILE__).'/includes/icalendar_2001/class.iCal.inc.php');
//$page = new FSTpl();

$max_items  = (intval(Req::val('num', 10)) == 10) ? 10 : 20;
$sql_project = '';
if ($proj->id) {
    $sql_project = ' AND p.project_id = ' . $proj->id;
}


if (Req::val('user_id')) {
$sql_user_1 = ' INNER JOIN {assigned}    a ON t.task_id = a.task_id';
    $sql_user_2 = ' AND u.user_id = ' . Req::val('user_id');
}

switch (Req::val('topic')) {
    case 'clo': $orderby = 'date_closed'; $closed = 0;
                $title   = 'Recently closed tasks';
    break;

    case 'edit':$orderby = 'last_edited_time'; $closed = 1;
                $title   = 'Recently edited tasks';
    break;

    default:    $orderby = 'date_opened'; $closed = 1;
                $title   = 'Recently opened tasks';
    break;
}

/* build a new feed if cache didn't work */
$sql = $db->Query("SELECT  t.task_id, t.item_summary, t.detailed_desc, t.date_opened, t.date_closed,
                           t.last_edited_time, t.opened_by, t.due_date, t.percent_complete, t.task_priority, t.is_closed, t.item_status, t.mark_private, lc.category_name, lt.tasktype_name, u.user_name, u.real_name, u.email_address, p.lang_code, d.task_id as task_id_depends
                     FROM  {tasks}    t
               INNER JOIN  {users}    u ON t.opened_by = u.user_id
               INNER JOIN  {list_category}    lc ON t.product_category = lc.category_id
               INNER JOIN  {list_tasktype}    lt ON t.task_type = lt.tasktype_id
               LEFT  JOIN  {dependencies}    d ON t.task_id = d.dep_task_id
               INNER JOIN  {projects} p ON t.attached_to_project = p.project_id AND p.project_is_active = '1'$sql_user_1
                    WHERE  t.is_closed <> ? $sql_project AND t.mark_private <> '1'
                           AND p.others_view = '1'$sql_user_2
                 ORDER BY  $orderby DESC", array($closed), $max_items);

$task_details     = $db->fetchAllArray($sql);
/*
This is an example if somebody is interessed to implement alarm export in flyspray

$alarm = (array) array(
					  0, // Action: 0 = DISPLAY, 1 = EMAIL, (not supported: 2 = AUDIO, 3 = PROCEDURE)
					  150,  // Trigger: alarm before the event in minutes
					  'Wake Up!', // Title
					  '...and go shopping', // Description
					  $attendees, // Array (key = attendee name, value = e-mail, second value = role of the attendee [0 = CHAIR | 1 = REQ | 2 = OPT | 3 =NON])
					  5, // Duration between the alarms in minutes
					  3  // How often should the alarm be repeated
					  );*/

$iCal = (object) new iCal('Flyspray', 1); // (ProgrammID, Method [1 = Publish | 0 = Request])

foreach($task_details as $event) {

if ($event['is_closed']) $event_status = 2; else
{
	if ($event['item_status'] == 1) $event_status = 0; else $event_status = 1;
}

$sql = $db->Query("SELECT  u.user_name, u.real_name, u.email_address
                     FROM  {assigned}    a
               INNER JOIN  {users}    u ON a.user_id = u.user_id
               INNER JOIN  {tasks}    t ON a.task_id = t.task_id
                    WHERE  t.task_id =$event[task_id]", array($closed));

$attendees_sql     = $db->fetchAllArray($sql);
foreach($attendees_sql as $att) {
$attendees["$att[real_name] ($att[user_name])"] = $att['email_address'].',1';
}

$iCal->addToDo(
			   $event['item_summary'], // Title
			   $event['detailed_desc'], // Description
			   $event['tasktype_name'], // Location
			   (int) $event['date_opened'], // Start time
			   '', // Duration in minutes
			   (int) $event['due_date'], // End time
			   (int) $event['percent_complete'], // Percentage complete
			   $event['task_priority'], // Priority = 0-9
			   $event_status, // Status of the event (0 = TENTATIVE, 1 = CONFIRMED, 2 = CANCELLED)
			   !$event['mark_private'], // Class (0 = PRIVATE | 1 = PUBLIC | 2 = CONFIDENTIAL)
			   (array) array($event['real_name'].' ('.$event['user_name'].')', $event['email_address']), // Organizer
			   $attendees, // Array (key = attendee name, value = e-mail, second value = role of the attendee [0 = CHAIR | 1 = REQ | 2 = OPT | 3 =NON])
			   array($event['category_name']), // Array with Strings
			   (int) $event['last_edited_time'], // Last Modification
			   array(''), // Sets the time in minutes an alarm appears before the event in the programm. no alarm if empty string or 0
			   '', // frequency: 0 = once, secoundly - yearly = 1-7
			   '', // recurrency end: ('' = forever | integer = number of times | timestring = explicit date)
			   '', // Interval for frequency (every 2,3,4 weeks...)
			   '', // Array with the number of the days the event accures (example: array(0,1,5) = Sunday, Monday, Friday
			   0, // Startday of the Week ( 0 = Sunday - 6 = Saturday)
			   '', // exeption dates: Array with timestamps of dates that should not be includes in the recurring event
			   htmlspecialchars(CreateURL('details', $event['task_id'])), // optional URL for that event
			   $event['lang_code'], // Language of the Strings
               $event['task_id'], // Optional UID for this ToDo
               $event['task_id_depends'] // Optional task depends UID for this ToDo
			  );

	if ($event['due_date']) // if a due date exists, it's possible to see this task in a calendar
	{
		$iCal->addEvent(
				(array) array($event['real_name'].' ('.$event['user_name'].')', $event['email_address']), // Organizer
				($event['due_date'] - 3600), // Start Time (timestamp; for an allday event the startdate has to start at YYYY-mm-dd 00:00:00)
				(int) $event['due_date'], // End Time (write 'allday' for an allday event instead of a timestamp)
				$event['tasktype_name'], // Location
				0, // Transparancy (0 = OPAQUE | 1 = TRANSPARENT)
				array($event['category_name']), // Array with Strings
				$event['detailed_desc'], // Description
				$event['item_summary'], // Title
				!$event['mark_private'], // Class (0 = PRIVATE | 1 = PUBLIC | 2 = CONFIDENTIAL)
				$attendees, // Array (key = attendee name, value = e-mail, second value = role of the attendee [0 = CHAIR | 1 = REQ | 2 = OPT | 3 =NON])
				$event['task_priority'], // Priority = 0-9
				'', // frequency: 0 = once, secoundly - yearly = 1-7
				'', // recurrency end: ('' = forever | integer = number of times | timestring = explicit date)
				'', // Interval for frequency (every 2,3,4 weeks...)
				'', // Array with the number of the days the event accures (example: array(0,1,5) = Sunday, Monday, Friday
				0, // Startday of the Week ( 0 = Sunday - 6 = Saturday)
				'', // exeption dates: Array with timestamps of dates that should not be includes in the recurring event
				array(''),  // Sets the time in minutes an alarm appears before the event in the programm. no alarm if empty string or 0
				$event_status, // Status of the event (0 = TENTATIVE, 1 = CONFIRMED, 2 = CANCELLED)
				htmlspecialchars(CreateURL('details', $event['task_id'])), // optional URL for that event
				$event['lang_code'], // Language of the Strings
                $event['task_id'] // Optional UID for this event
			   );
	}
}


//IE compatibiltiy HACK!
if(ini_get('zlib.output_compression')) {
    ini_set('zlib.output_compression', 'Off');
}
$iCal->outputFile('ics'); // output file as ics (xcs and rdf possible)
?>
